BTM = {}
BTM.name = "BanyusTrialMarkers"
BTM.default_color = { 1, 1, 1 }

MARKERS = {
    MT = nil,
    OT = nil,
    GH = nil,
    KH = nil,
    FIRE = nil,
    ICE = nil,
    BOSS = nil
}

function BTM.OnAddOnLoaded(event, addonName)
    if (addonName ~= BTM.name) then
        return
    end
    EVENT_MANAGER:UnregisterForEvent(BTM.name, EVENT_ADD_ON_LOADED)

    if OSI and OSI.CreatePositionIcon then
        EVENT_MANAGER:RegisterForEvent(BTM.name, EVENT_PLAYER_ACTIVATED, BTM.PlaceAvailableMarkers)
        EVENT_MANAGER:RegisterForEvent(BTM.name, EVENT_BOSSES_CHANGED, BTM.PlaceAvailableMarkers)
    end
end

function BTM.PlaceAvailableMarkers()
    BTM.ClearMarkers()
    local zone = GetUnitRawWorldPosition("player")
    local boss = GetUnitName("boss1")

    if zone == 1051 then
        -- Cloudrest
        if boss then
            if boss == "Shade of Galenwe" then
                BTM.PlaceMTIcon(167787, 32027, 85743)
                BTM.PlaceOTIcon(164378, 32027, 85614)
                BTM.PlaceKHIcon(166051, 32027, 89002)
            end
            if boss == "Shade of Siroria" then
                BTM.PlaceMTIcon(149877, 30941, 90247)
                BTM.PlaceOTIcon(152334, 30941, 88051)
                BTM.PlaceKHIcon(153095, 30941, 91519)

            end
            if boss == "Shade of Relequen" then
                BTM.PlaceMTIcon(150346, 32802, 103580)
                BTM.PlaceOTIcon(152552, 32802, 101070)
                BTM.PlaceKHIcon(153916, 32802, 104023)
            end
        end
    elseif zone == 1344 then
        -- Dreadsail Reef
        if boss then
            if boss == "Lylanar" then
                -- Boss Starting Position
                BTM.PlaceBossIcon(69968, 36125, 85168)
                BTM.PlaceIceIcon(68569, 36125, 83708)
                BTM.PlaceFireIcon(68544, 36125, 86582)
                BTM.PlaceDPSIcon(69749, 36125, 85163)
            end

            if boss == "Tideborn Taleria" then
                BTM.PlaceMTIcon(168000, 36126, 28616)
                BTM.PlaceDPSIcon(167700, 36125, 30175)
                BTM.PlaceKHIcon(167550, 36125, 30175)
                BTM.PlaceGHIcon(167560, 36125, 30230)
            end
        end
    elseif zone == 975 then
        -- Halls of Fabrication
        if boss then
            if boss == "Hunter-Killer Negatrix" then
                -- Raptors
                BTM.PlaceDPSIcon(41605, 49950, 27570)
                BTM.PlaceGHIcon(41518, 49950, 27700)
                BTM.PlaceBossIcon(41755, 49950, 27350)

                BTM.PlaceBossIcon(41050, 49950, 24750)
                BTM.PlaceOTIcon(40860, 49950, 24625)
            end
            if boss == "Reactor" then
                -- Committee
                BTM.PlaceBossIcon(28250, 52950, 72000)
                BTM.PlaceMTIcon(28000, 52950, 72000)
                BTM.PlaceDPSIcon(28500, 52950, 72000)
                BTM.PlaceGHIcon(28600, 52950, 72000)

                BTM.PlaceBossIcon(28250, 52950, 74500)
                BTM.PlaceOTIcon(28000, 52950, 74500)
                BTM.PlaceDPSIcon(28500, 52950, 74500)
                BTM.PlaceKHIcon(28600, 52950, 74500)
            end
            if boss == "Assembly General" then
                -- Boss Execute Positions
                BTM.PlaceBossIcon(75000, 54925, 70000)
                BTM.Place1Icon(75000, 54950, 69500)
                BTM.Place2Icon(74500, 54950, 70000)
                BTM.Place3Icon(75000, 54950, 70500)
                BTM.Place4Icon(75500, 54950, 70000)
                BTM.PlaceMTIcon(75375, 54950, 69625)
                BTM.PlaceOTIcon(74625, 54950, 70375)
                BTM.PlaceGHIcon(75375, 54950, 70375)
                BTM.PlaceKHIcon(74625, 54950, 69625)
            end
        end
    elseif zone == 1000 then
        -- Asylum Sanctorum
        if boss then
            if boss == "Saint Olms the Just" then
                BOSS_X = 98800
                BOSS_Z = 101250
                X_SPACING = 400
                Z_SPACING = 750

                VAS_Y = 61450
                BTM.PlaceBossIcon(BOSS_X, VAS_Y, BOSS_Z)
                BTM.PlaceMTIcon(98800, VAS_Y, 101750)
                BTM.PlaceKHIcon(98800, VAS_Y, 103750)
                BTM.PlaceKHIcon(98800, VAS_Y, 96750)

                -- Calculate lane marker positions based on ending point.
                LANE_1_X = BOSS_X - X_SPACING * 5.65
                LANE_1_Z = BOSS_Z - Z_SPACING * 2.65
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_1_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_1_Z, positionNumber)
                    BTM.Place1Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_2_X = BOSS_X - X_SPACING * 4.3
                LANE_2_Z = BOSS_Z - Z_SPACING * 3.3
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_2_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_2_Z, positionNumber)
                    BTM.Place2Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_3_X = BOSS_X - X_SPACING * 2.75
                LANE_3_Z = BOSS_Z - Z_SPACING * 3.75
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_3_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_3_Z, positionNumber)
                    BTM.Place3Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_4_X = BOSS_X - X_SPACING
                LANE_4_Z = BOSS_Z - Z_SPACING * 4
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_4_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_4_Z, positionNumber)
                    BTM.Place4Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_5_X = BOSS_X + X_SPACING
                LANE_5_Z = BOSS_Z - Z_SPACING * 4
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_5_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_5_Z, positionNumber)
                    BTM.Place5Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_6_X = BOSS_X + X_SPACING * 2.75
                LANE_6_Z = BOSS_Z - Z_SPACING * 3.75
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_6_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_6_Z, positionNumber)
                    BTM.Place6Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_7_X = BOSS_X + X_SPACING * 4.3
                LANE_7_Z = BOSS_Z - Z_SPACING * 3.3
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_7_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_7_Z, positionNumber)
                    BTM.Place7Icon(LANE_X, VAS_Y, LANE_Z)
                end

                LANE_8_X = BOSS_X + X_SPACING * 5.65
                LANE_8_Z = BOSS_Z - Z_SPACING * 2.65
                for positionNumber = 1, 5 do
                    LANE_X = BTM.GetCoordinateDifferential(BOSS_X, LANE_8_X, positionNumber)
                    LANE_Z = BTM.GetCoordinateDifferential(BOSS_Z, LANE_8_Z, positionNumber)
                    BTM.Place8Icon(LANE_X, VAS_Y, LANE_Z)
                end
            end
        end
    end
end

EVENT_MANAGER:RegisterForEvent(BTM.name, EVENT_ADD_ON_LOADED, BTM.OnAddOnLoaded)